#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct lista
{
    char nome[31];
    int numero;
    struct lista *prox;
}Lista;

void busca (Lista *head, char nome[])
{
    Lista *temp = head;
    int achou = 0;
    while (temp != NULL)
    {
        if (strcmp (nome, temp->nome) == 0)
        {
            achou = 1;
            printf ("\n");
            puts (nome);
            printf ("%d", temp->numero);
            printf ("\n");
        }
        temp = temp->prox;
    }
    if (achou == 0)
    {
        printf ("\nEsta pessoa nao foi encontrada\n");
    }
}

Lista *insere (Lista *head, char nome[], int telefone)
{
    Lista *temp, *temp2, *novo;

    novo = (Lista *) malloc (sizeof (Lista));
    strcpy (novo->nome, nome);
    novo->numero = telefone;

    if (head == NULL)
    {
        head = novo;
        head->prox = NULL;
    }
    else if (strcmp (head->nome, nome) > 0)
    {
        novo->prox = head;
        head = novo;
    }
    else
    {
        temp2 = head;
        temp = temp2 -> prox;
        while (temp != NULL && (strcmp (temp->nome,nome) < 0))
        {
            temp2 = temp;
            temp = temp -> prox;
        }
        temp2 -> prox = novo;
        novo-> prox = temp;
    }
    return head;
}

Lista *remove (Lista *head, char nome[])
{
    Lista *temp, *temp2;
    if (head != NULL)
    {
        if (strcmp(head->nome, nome) == 0)
        {
            temp = head;
            head = head->prox;
        }
        else
        {
            temp2 = head;
            temp = head->prox;
            while (temp != NULL && (strcmp (temp->nome, nome) != 0))
            {
                temp2 = temp;
                temp = temp -> prox;
            }
            if (strcmp(temp->nome, nome) == 0)
            {
                temp2 -> prox = temp->prox;
            }
        }
        free (temp);
    }
    return head;
}

void imprime (Lista *head)
{
    Lista *temp = head;
    while (temp != NULL)
    {
        printf ("\n");
        puts (temp->nome);
        printf ("Telefone: %d", temp->numero);
        printf ("\n");
        temp = temp -> prox;
    }
}


int main()
{
    Lista *head = NULL;
    int opcao, telefone;
    char nome[31];
    do
    {
        printf ("\nDigite o que vc deseja fazer:");
        printf ("\nDigite 1 para fazer Busca por nome");
        printf ("\nDigite 2 para fazer uma insercao");
        printf ("\nDigite 3 para fazer uma remocao");
        printf ("\nDigite 4 para imprimir a lista");
        printf ("\nDigite 0 para finalizar o programa:\n");
        scanf ("%d", &opcao);
        switch (opcao)
        {
            case 0:
            {
                break;
            }
            case 1:
            {
                printf ("Digite o nome para busca-lo: ");
                fflush (stdin);
                gets (nome);
                busca (head, nome);
                break;
            }
            case 2:
            {
                printf ("Digite o nome a ser adicionado: ");
                fflush (stdin);
                gets (nome);
                do
                {
                    printf ("\nDigite o telefone: ");
                    scanf ("%d", &telefone);
                    if (telefone < 0)
                    {
                        printf ("\nNumero invalido\n");
                    }
                }
                while (telefone < 0);
                head = insere (head, nome, telefone);
                break;
            }
            case 3:
            {
                printf ("Digite o nome a ser removido: ");
                fflush (stdin);
                gets (nome);
                head = remove (head, nome);
                break;
            }
            case 4:
            {
                imprime (head);
                break;
            }
            default:
            {
                printf ("\nOpcao invalida!!!!!");
            }
        }
    }
    while (opcao != 0);
    return 0;
}



